package linkedqueue;

public class LinkedQueueDriver {

    /*@ behavior
       @    ensures true;
       @*/
    public static void main(String[] args) {
        LinkedQueue lq = new LinkedQueue();
        new Process(lq).start();
        new Process(lq).start();
    }
}

class Process extends Thread {
    /*@ instance invariant lq != null; @*/
    final LinkedQueue lq;

    /*@ behavior
       @    requires lq != null;
       @    assignable this.lq;
       @    ensures this.lq == lq;
       @*/
    Process(LinkedQueue lq) {
        this.lq = lq;
    }

    /*@also
       @ behavior
       @    diverges true;
       @    ensures false;
       @*/
    public void run() {
        Object data = new Object();
        while (true) {
            lq.put(data);
            data = lq.take();
        }
    }
}
